.686
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE

INCLUDE		windows.inc

INCLUDE		kernel32.inc
INCLUDELIB	kernel32.lib

INCLUDE		masm32.inc
INCLUDELIB	masm32.lib

INCLUDE		msvcrt.inc
INCLUDELIB	msvcrt.lib

INCLUDE		c:\masm32\macros\macros.asm
INCLUDE		c:\masm32\macros\timers.asm



TEST_LIMIT1	=	  100000h
TEST_LIMIT2	=	10000000h

INCREASE_STEP_1	=	    4000h
INCREASE_STEP_2	=	   80000h

LOOP_COUNT	=	1
.DATA
	hHeapApp		DWORD			0
	pMem			DWORD			0
	MemoryCounter		DWORD			1000h
	Rez1			DWORD			0
	Rez2			DWORD			0
.CODE

DoATest	PROC	BytesCount:DWORD
	
	print hex$(BytesCount), 9,"|",9
	
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		INVOKE	HeapAlloc,	hHeapApp,0,BytesCount
		mov	pMem,		eax
	counter_end
	mov	Rez1,		eax
	print str$(eax),9
	.IF	pMem!=0
		INVOKE	HeapFree,	hHeapApp,0,pMem
		write	<"OK",9,"|",9>
		mov	pMem,		0
	.ELSE
		write	<"FAILED",9,"|",9>
	.ENDIF
	
	
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		INVOKE	VirtualAlloc,	NULL,BytesCount,MEM_COMMIT or MEM_RESERVE,PAGE_READWRITE
		mov	pMem,		eax
	counter_end
	mov	Rez2,		eax
	print str$(eax)
	.IF	pMem!=0
		INVOKE	VirtualFree,	pMem,0,MEM_RELEASE
		write	<9,"OK",9,"|",9>
		mov	pMem,		0
	.ELSE
		write	<9,"FAILED",9,"|",9>
	.ENDIF
	mov	eax,		Rez1
	sub	eax,		Rez2
	print	str$(eax),9,"|",13,10
	
	ret

DoATest		ENDP



App_Entry_Point:

	mov	esi,			INCREASE_STEP_1
	mov	edi,			TEST_LIMIT1
	INVOKE	GetProcessHeap
	mov	hHeapApp,		eax
	write	13,10,"Indepth test...",13,10
	write	"=================================================================================",13,10
	write	"BYTES",9, 9,"|",9,"HA",9,"STS",9,"|",9,"VA",9,"STS",9,"|",9,"HA-VA",9,"|",13,10
	write	"=================================================================================",13,10
	
	LoopTest_Heap:
		INVOKE	DoATest,		MemoryCounter
		add	MemoryCounter,		esi

	cmp	MemoryCounter,		edi
	jbe	LoopTest_Heap
	cmp	edi,		TEST_LIMIT2
	je	@F
		mov	esi,		INCREASE_STEP_2
		mov	edi,		TEST_LIMIT2
		jmp	LoopTest_Heap
	@@:
	write	"=================================================================================",13,10
	write	"=================================================================================",13,10,13,10
	
	
	write	"Here is a small sample that you can post back...",13,10
	write	"=================================================================================",13,10
	write	"BYTES",9, 9,"|",9,"HA",9,"STS",9,"|",9,"VA",9,"STS",9,"|",9,"HA-VA",9,"|",13,10
	write	"=================================================================================",13,10
		INVOKE	DoATest,		    1000h
		INVOKE	DoATest,		   10000h
		INVOKE	DoATest,		  100000h
		INVOKE	DoATest,		 1000000h
		INVOKE	DoATest,		10000000h
	
	write	"=================================================================================",13,10
	write	"=================================================================================",13,10,13,10
	
	inkey	"Print any key to exit ..."
	
	
	
	
	INVOKE	ExitProcess,	NULL
END App_Entry_Point